# encoding: utf-8
#
# Copyright 2016 Game Server Services, Inc. or its affiliates. All Rights
# Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License.
# A copy of the License is located at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
# or in the "license" file accompanying this file. This file is distributed
# on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
# express or implied. See the License for the specific language governing
# permissions and limitations under the License.


class Prize(object):

    def __init__(self, params=None):
        if params is None:
            self.__gacha_pool_name = None
            self.__gacha_name = None
            self.__resource_ids = None
        else:
            self.set_gacha_pool_name(params['gachaPoolName'] if 'gachaPoolName' in params.keys() else None)
            self.set_gacha_name(params['gachaName'] if 'gachaName' in params.keys() else None)
            self.set_resource_ids(params['resourceIds'] if 'resourceIds' in params.keys() else None)

    def get_gacha_pool_name(self):
        """
        ガチャプール名を取得
        :return: ガチャプール名
        :rtype: unicode
        """
        return self.__gacha_pool_name

    def set_gacha_pool_name(self, gacha_pool_name):
        """
        ガチャプール名を設定
        :param gacha_pool_name: ガチャプール名
        :type gacha_pool_name: unicode
        """
        self.__gacha_pool_name = gacha_pool_name

    def get_gacha_name(self):
        """
        ガチャ名を取得
        :return: ガチャ名
        :rtype: unicode
        """
        return self.__gacha_name

    def set_gacha_name(self, gacha_name):
        """
        ガチャ名を設定
        :param gacha_name: ガチャ名
        :type gacha_name: unicode
        """
        self.__gacha_name = gacha_name

    def get_resource_ids(self):
        """
        景品リストを取得
        :return: 景品リスト
        :rtype: list[unicode]
        """
        return self.__resource_ids

    def set_resource_ids(self, resource_ids):
        """
        景品リストを設定
        :param resource_ids: 景品リスト
        :type resource_ids: list[unicode]
        """
        self.__resource_ids = resource_ids

    def __getitem__(self, key):
        items = self.to_dict()
        if key in items.keys():
            return items[key]
        return super(Prize, self).__getitem__(key)

    def to_dict(self):
        return {
            "gachaPoolName": self.__gacha_pool_name,
            "gachaName": self.__gacha_name,
            "resourceIds": self.__resource_ids,
        }
