# encoding: utf-8
#
# Copyright 2016 Game Server Services, Inc. or its affiliates. All Rights
# Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License.
# A copy of the License is located at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
# or in the "license" file accompanying this file. This file is distributed
# on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
# express or implied. See the License for the specific language governing
# permissions and limitations under the License.


class Probability(object):

    def __init__(self, params=None):
        if params is None:
            self.__name = None
            self.__rate = None
        else:
            self.set_name(params['name'] if 'name' in params.keys() else None)
            self.set_rate(params['rate'] if 'rate' in params.keys() else None)

    def get_name(self):
        """
        レアリティ名を取得
        :return: レアリティ名
        :rtype: unicode
        """
        return self.__name

    def set_name(self, name):
        """
        レアリティ名を設定
        :param name: レアリティ名
        :type name: unicode
        """
        self.__name = name

    def get_rate(self):
        """
        排出率を取得
        :return: 排出率
        :rtype: float
        """
        return self.__rate

    def set_rate(self, rate):
        """
        排出率を設定
        :param rate: 排出率
        :type rate: float
        """
        self.__rate = rate

    def __getitem__(self, key):
        items = self.to_dict()
        if key in items.keys():
            return items[key]
        return super(Probability, self).__getitem__(key)

    def to_dict(self):
        return {
            "name": self.__name,
            "rate": self.__rate,
        }
