# encoding: utf-8
#
# Copyright 2016 Game Server Services, Inc. or its affiliates. All Rights
# Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License.
# A copy of the License is located at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
# or in the "license" file accompanying this file. This file is distributed
# on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
# express or implied. See the License for the specific language governing
# permissions and limitations under the License.


class ProbabilityDetail(object):

    def __init__(self, params=None):
        if params is None:
            self.__rarity_name = None
            self.__resource_id = None
            self.__rate = None
        else:
            self.set_rarity_name(params['rarityName'] if 'rarityName' in params.keys() else None)
            self.set_resource_id(params['resourceId'] if 'resourceId' in params.keys() else None)
            self.set_rate(params['rate'] if 'rate' in params.keys() else None)

    def get_rarity_name(self):
        """
        レアリティ名を取得
        :return: レアリティ名
        :rtype: unicode
        """
        return self.__rarity_name

    def set_rarity_name(self, rarity_name):
        """
        レアリティ名を設定
        :param rarity_name: レアリティ名
        :type rarity_name: unicode
        """
        self.__rarity_name = rarity_name

    def get_resource_id(self):
        """
        リソースIDを取得
        :return: リソースID
        :rtype: unicode
        """
        return self.__resource_id

    def set_resource_id(self, resource_id):
        """
        リソースIDを設定
        :param resource_id: リソースID
        :type resource_id: unicode
        """
        self.__resource_id = resource_id

    def get_rate(self):
        """
        排出率を取得
        :return: 排出率
        :rtype: float
        """
        return self.__rate

    def set_rate(self, rate):
        """
        排出率を設定
        :param rate: 排出率
        :type rate: float
        """
        self.__rate = rate

    def __getitem__(self, key):
        items = self.to_dict()
        if key in items.keys():
            return items[key]
        return super(ProbabilityDetail, self).__getitem__(key)

    def to_dict(self):
        return {
            "rarityName": self.__rarity_name,
            "resourceId": self.__resource_id,
            "rate": self.__rate,
        }
